import DataUtils from '../utils/DataUtils';
import VerifyUtils from '../utils/VerifyUtils';
import SimpleLineLayer from '../common/SimpleLineLayer';

/**
 * 定义排水渠图层
 *
 * @alias DitchLayer
 *
 * @summary <用于加载排水渠图层>
 */
 export default class DitchLayer {
  /**
   * 构造函数
   * @param {Object} options -图层选项
   */
  constructor(options) {
    /**
     * 地图对象
     * @type {Object}
     */
    this._map = options.map;

    /**
     * 最小缩放层级
     * @type {Number}
     */
    this._minzoom = DataUtils.default(options.minzoom, 10);

    /**
     * 线颜色
     * @type {String}
     */
    this._lineColor = DataUtils.default(options.color, '#17EEDC');

    /**
     * 线宽
     * @type {Number}
     */
    this._lineWidth = DataUtils.default(options.width, 7.5);

    /**
     * 透明度
     * @type {Number} (0-1)
     */
    this._lineOpacity = DataUtils.default(options.opacity, 1.0);

    /**
     * 过滤条件数组
     * @type {Array}
     */
    this._filter = DataUtils.default(options.filter, undefined);

    /**
     * 数据源ID
     * @typr {String}
     */
    this._sourceId = DataUtils.default(options.sourceId, 'pipe_ditch');

    /**
     * 图层ID
     * @typr {String}
     */
    this._layerId = DataUtils.default(options.layerId, this._sourceId);

    /* 图层对象 */
    this._lineLayer = new SimpleLineLayer({
      map: this._map,
      minzoom: this._minzoom,
      //color: this._lineColor,
      color: {
        type: 'categorical',
        property: 'ditch_type',
        stops: [
          ['1', '#17EEDC'],
          ['2', '#006C63']
        ],
        default: '#17EEDC'
      },
      width: this._lineWidth,
      opacity: this._lineOpacity,
      filter: this._filter,
      sourceId: this._sourceId,
      layerId: this._layerId
    });
  }

  /** 公有方法 **/
  /**
   * 设置数据
   * @param {Object|String} data -数据/过滤条件
   */
  setData(data = null) {
    // 加载图层
    this.loadLayer();

    if (data) {
      this._lineLayer.setData(data);
    }
  }

  /**
   * 设置筛选器
   * @param {Array} filter -筛选器
   */
  setFilter(filter) {
    this._lineLayer.setFilter(filter);
  }

  /**
   * 加载图层
   */
  loadLayer() {
    // 加载图层
    if (!this.hasLayer()) {
      this._lineLayer.loadLayer();
    }

    // 显示图层
    this.showLayer(true);
  }

  /**
   * 显示/隐藏图层
   * @param {Boolean} isShow -是否显示图层
   */
  showLayer(isShow) {
    this._lineLayer.showLayer(isShow);
  }

  /**
   * 判断图层是否已加载
   *
   * @returns {Boolean}
   */
  hasLayer() {
    return this._lineLayer.hasLayer();
  }


  /**
   * 移除图层
   */
  removeLayer() {
    this._lineLayer.removeLayer();
  }

  /**
   * 移除数据源
   */
  removeSource() {
    this._lineLayer.removeSource();
  }

  /**
   * 绑定单击事件
   * @param {Function} event -事件函数
   */
  onClick(event) {
    this._lineLayer.onClick(event);
  }

  /**
   * 绑定事件
   * @param {String} name -事件名称
   * @param {Function} event -事件函数
   */
  onEvent(name, event) {
    this._lineLayer.onEvent(name, event);
  }
}
